package data

import (
  "github.com/gofiber/fiber/v2"
   _ "github.com/mattn/go-sqlite3"
   "github.com/jmoiron/sqlx"
 )

func SelectJson[T any](db *sqlx.DB, c *fiber.Ctx, err error, sql string, args ...interface{}) error {
  var result []T
  if err != nil { goto fail }

  err = db.Select(&result, sql, args...)
  if err != nil { goto fail }

  return c.JSON(&result)

fail: return err
}

func GetJson[T any](db *sqlx.DB, c *fiber.Ctx, err error, sql string, args ...interface{}) error {
  var result T
  if err != nil { goto fail }

  err = db.Get(&result, sql, args...)
  if err != nil { goto fail }

  return c.JSON(&result)

fail: return err
}

func Insert(db *sqlx.DB, err error, sql_query string, args ...interface{}) error {
  if err != nil { return err }

  db.MustExec(sql_query, args...)
  return err
}


